# pulp_hugging_face-client
Fetch, Upload, Organize, and Distribute Software Packages

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: v3
- Package version: 0.0.1
- Generator version: 7.10.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen
For more information, please visit [https://pulpproject.org](https://pulpproject.org)

## Requirements.

Python 3.8+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import pulpcore.client.pulp_hugging_face
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import pulpcore.client.pulp_hugging_face
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import pulpcore.client.pulp_hugging_face
from pulpcore.client.pulp_hugging_face.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost:24817
# See configuration.py for a list of all supported configuration parameters.
configuration = pulpcore.client.pulp_hugging_face.Configuration(
    host = "http://localhost:24817"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure HTTP basic authorization: basicAuth
configuration = pulpcore.client.pulp_hugging_face.Configuration(
    username = os.environ["USERNAME"],
    password = os.environ["PASSWORD"]
)

# Configure API key authorization: cookieAuth
configuration.api_key['cookieAuth'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['cookieAuth'] = 'Bearer'


# Enter a context with an instance of the API client
with pulpcore.client.pulp_hugging_face.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = pulpcore.client.pulp_hugging_face.ContentHuggingFaceApi(api_client)
    hugging_face_hugging_face_content = pulpcore.client.pulp_hugging_face.HuggingFaceHuggingFaceContent() # HuggingFaceHuggingFaceContent | 
    x_task_diagnostics = ['x_task_diagnostics_example'] # List[str] | List of profilers to use on tasks. (optional)

    try:
        # Create a hugging face content
        api_response = api_instance.create(hugging_face_hugging_face_content, x_task_diagnostics=x_task_diagnostics)
        print("The response of ContentHuggingFaceApi->create:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling ContentHuggingFaceApi->create: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost:24817*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*ContentHuggingFaceApi* | [**create**](docs/ContentHuggingFaceApi.md#create) | **POST** /pulp/api/v3/content/hugging_face/hugging-face/ | Create a hugging face content
*ContentHuggingFaceApi* | [**list**](docs/ContentHuggingFaceApi.md#list) | **GET** /pulp/api/v3/content/hugging_face/hugging-face/ | List hugging face contents
*ContentHuggingFaceApi* | [**read**](docs/ContentHuggingFaceApi.md#read) | **GET** {hugging_face_hugging_face_content_href} | Inspect a hugging face content
*ContentHuggingFaceApi* | [**set_label**](docs/ContentHuggingFaceApi.md#set_label) | **POST** {hugging_face_hugging_face_content_href}set_label/ | Set a label
*ContentHuggingFaceApi* | [**unset_label**](docs/ContentHuggingFaceApi.md#unset_label) | **POST** {hugging_face_hugging_face_content_href}unset_label/ | Unset a label
*DistributionsHuggingFaceApi* | [**create**](docs/DistributionsHuggingFaceApi.md#create) | **POST** /pulp/api/v3/distributions/hugging_face/hugging-face/ | Create a hugging face distribution
*DistributionsHuggingFaceApi* | [**delete**](docs/DistributionsHuggingFaceApi.md#delete) | **DELETE** {hugging_face_hugging_face_distribution_href} | Delete a hugging face distribution
*DistributionsHuggingFaceApi* | [**list**](docs/DistributionsHuggingFaceApi.md#list) | **GET** /pulp/api/v3/distributions/hugging_face/hugging-face/ | List hugging face distributions
*DistributionsHuggingFaceApi* | [**partial_update**](docs/DistributionsHuggingFaceApi.md#partial_update) | **PATCH** {hugging_face_hugging_face_distribution_href} | Update a hugging face distribution
*DistributionsHuggingFaceApi* | [**read**](docs/DistributionsHuggingFaceApi.md#read) | **GET** {hugging_face_hugging_face_distribution_href} | Inspect a hugging face distribution
*DistributionsHuggingFaceApi* | [**set_label**](docs/DistributionsHuggingFaceApi.md#set_label) | **POST** {hugging_face_hugging_face_distribution_href}set_label/ | Set a label
*DistributionsHuggingFaceApi* | [**unset_label**](docs/DistributionsHuggingFaceApi.md#unset_label) | **POST** {hugging_face_hugging_face_distribution_href}unset_label/ | Unset a label
*DistributionsHuggingFaceApi* | [**update**](docs/DistributionsHuggingFaceApi.md#update) | **PUT** {hugging_face_hugging_face_distribution_href} | Update a hugging face distribution
*PublicationsHuggingFaceApi* | [**create**](docs/PublicationsHuggingFaceApi.md#create) | **POST** /pulp/api/v3/publications/hugging_face/hugging-face/ | Create a hugging face publication
*PublicationsHuggingFaceApi* | [**delete**](docs/PublicationsHuggingFaceApi.md#delete) | **DELETE** {hugging_face_hugging_face_publication_href} | Delete a hugging face publication
*PublicationsHuggingFaceApi* | [**list**](docs/PublicationsHuggingFaceApi.md#list) | **GET** /pulp/api/v3/publications/hugging_face/hugging-face/ | List hugging face publications
*PublicationsHuggingFaceApi* | [**read**](docs/PublicationsHuggingFaceApi.md#read) | **GET** {hugging_face_hugging_face_publication_href} | Inspect a hugging face publication
*RemotesHuggingFaceApi* | [**create**](docs/RemotesHuggingFaceApi.md#create) | **POST** /pulp/api/v3/remotes/hugging_face/hugging-face/ | Create a hugging face remote
*RemotesHuggingFaceApi* | [**delete**](docs/RemotesHuggingFaceApi.md#delete) | **DELETE** {hugging_face_hugging_face_remote_href} | Delete a hugging face remote
*RemotesHuggingFaceApi* | [**list**](docs/RemotesHuggingFaceApi.md#list) | **GET** /pulp/api/v3/remotes/hugging_face/hugging-face/ | List hugging face remotes
*RemotesHuggingFaceApi* | [**partial_update**](docs/RemotesHuggingFaceApi.md#partial_update) | **PATCH** {hugging_face_hugging_face_remote_href} | Update a hugging face remote
*RemotesHuggingFaceApi* | [**read**](docs/RemotesHuggingFaceApi.md#read) | **GET** {hugging_face_hugging_face_remote_href} | Inspect a hugging face remote
*RemotesHuggingFaceApi* | [**set_label**](docs/RemotesHuggingFaceApi.md#set_label) | **POST** {hugging_face_hugging_face_remote_href}set_label/ | Set a label
*RemotesHuggingFaceApi* | [**unset_label**](docs/RemotesHuggingFaceApi.md#unset_label) | **POST** {hugging_face_hugging_face_remote_href}unset_label/ | Unset a label
*RemotesHuggingFaceApi* | [**update**](docs/RemotesHuggingFaceApi.md#update) | **PUT** {hugging_face_hugging_face_remote_href} | Update a hugging face remote
*RepositoriesHuggingFaceApi* | [**create**](docs/RepositoriesHuggingFaceApi.md#create) | **POST** /pulp/api/v3/repositories/hugging_face/hugging-face/ | Create a hugging face repository
*RepositoriesHuggingFaceApi* | [**delete**](docs/RepositoriesHuggingFaceApi.md#delete) | **DELETE** {hugging_face_hugging_face_repository_href} | Delete a hugging face repository
*RepositoriesHuggingFaceApi* | [**list**](docs/RepositoriesHuggingFaceApi.md#list) | **GET** /pulp/api/v3/repositories/hugging_face/hugging-face/ | List hugging face repositorys
*RepositoriesHuggingFaceApi* | [**modify**](docs/RepositoriesHuggingFaceApi.md#modify) | **POST** {hugging_face_hugging_face_repository_href}modify/ | Modify Repository Content
*RepositoriesHuggingFaceApi* | [**partial_update**](docs/RepositoriesHuggingFaceApi.md#partial_update) | **PATCH** {hugging_face_hugging_face_repository_href} | Update a hugging face repository
*RepositoriesHuggingFaceApi* | [**read**](docs/RepositoriesHuggingFaceApi.md#read) | **GET** {hugging_face_hugging_face_repository_href} | Inspect a hugging face repository
*RepositoriesHuggingFaceApi* | [**set_label**](docs/RepositoriesHuggingFaceApi.md#set_label) | **POST** {hugging_face_hugging_face_repository_href}set_label/ | Set a label
*RepositoriesHuggingFaceApi* | [**sync**](docs/RepositoriesHuggingFaceApi.md#sync) | **POST** {hugging_face_hugging_face_repository_href}sync/ | Sync from remote
*RepositoriesHuggingFaceApi* | [**unset_label**](docs/RepositoriesHuggingFaceApi.md#unset_label) | **POST** {hugging_face_hugging_face_repository_href}unset_label/ | Unset a label
*RepositoriesHuggingFaceApi* | [**update**](docs/RepositoriesHuggingFaceApi.md#update) | **PUT** {hugging_face_hugging_face_repository_href} | Update a hugging face repository
*RepositoriesHuggingFaceVersionsApi* | [**delete**](docs/RepositoriesHuggingFaceVersionsApi.md#delete) | **DELETE** {hugging_face_hugging_face_repository_version_href} | Delete a repository version
*RepositoriesHuggingFaceVersionsApi* | [**list**](docs/RepositoriesHuggingFaceVersionsApi.md#list) | **GET** {hugging_face_hugging_face_repository_href}versions/ | List repository versions
*RepositoriesHuggingFaceVersionsApi* | [**read**](docs/RepositoriesHuggingFaceVersionsApi.md#read) | **GET** {hugging_face_hugging_face_repository_version_href} | Inspect a repository version
*RepositoriesHuggingFaceVersionsApi* | [**repair**](docs/RepositoriesHuggingFaceVersionsApi.md#repair) | **POST** {hugging_face_hugging_face_repository_version_href}repair/ | 


## Documentation For Models

 - [AsyncOperationResponse](docs/AsyncOperationResponse.md)
 - [ContentSummaryResponse](docs/ContentSummaryResponse.md)
 - [HuggingFaceHuggingFaceContent](docs/HuggingFaceHuggingFaceContent.md)
 - [HuggingFaceHuggingFaceContentResponse](docs/HuggingFaceHuggingFaceContentResponse.md)
 - [HuggingFaceHuggingFaceDistribution](docs/HuggingFaceHuggingFaceDistribution.md)
 - [HuggingFaceHuggingFaceDistributionResponse](docs/HuggingFaceHuggingFaceDistributionResponse.md)
 - [HuggingFaceHuggingFacePublication](docs/HuggingFaceHuggingFacePublication.md)
 - [HuggingFaceHuggingFacePublicationResponse](docs/HuggingFaceHuggingFacePublicationResponse.md)
 - [HuggingFaceHuggingFaceRemote](docs/HuggingFaceHuggingFaceRemote.md)
 - [HuggingFaceHuggingFaceRemoteResponse](docs/HuggingFaceHuggingFaceRemoteResponse.md)
 - [HuggingFaceHuggingFaceRemoteResponseHiddenFieldsInner](docs/HuggingFaceHuggingFaceRemoteResponseHiddenFieldsInner.md)
 - [HuggingFaceHuggingFaceRepository](docs/HuggingFaceHuggingFaceRepository.md)
 - [HuggingFaceHuggingFaceRepositoryResponse](docs/HuggingFaceHuggingFaceRepositoryResponse.md)
 - [PaginatedRepositoryVersionResponseList](docs/PaginatedRepositoryVersionResponseList.md)
 - [PaginatedhuggingFaceHuggingFaceContentResponseList](docs/PaginatedhuggingFaceHuggingFaceContentResponseList.md)
 - [PaginatedhuggingFaceHuggingFaceDistributionResponseList](docs/PaginatedhuggingFaceHuggingFaceDistributionResponseList.md)
 - [PaginatedhuggingFaceHuggingFacePublicationResponseList](docs/PaginatedhuggingFaceHuggingFacePublicationResponseList.md)
 - [PaginatedhuggingFaceHuggingFaceRemoteResponseList](docs/PaginatedhuggingFaceHuggingFaceRemoteResponseList.md)
 - [PaginatedhuggingFaceHuggingFaceRepositoryResponseList](docs/PaginatedhuggingFaceHuggingFaceRepositoryResponseList.md)
 - [PatchedhuggingFaceHuggingFaceDistribution](docs/PatchedhuggingFaceHuggingFaceDistribution.md)
 - [PatchedhuggingFaceHuggingFaceRemote](docs/PatchedhuggingFaceHuggingFaceRemote.md)
 - [PatchedhuggingFaceHuggingFaceRepository](docs/PatchedhuggingFaceHuggingFaceRepository.md)
 - [PolicyEnum](docs/PolicyEnum.md)
 - [Repair](docs/Repair.md)
 - [RepoTypeEnum](docs/RepoTypeEnum.md)
 - [RepositoryAddRemoveContent](docs/RepositoryAddRemoveContent.md)
 - [RepositorySyncURL](docs/RepositorySyncURL.md)
 - [RepositoryVersionResponse](docs/RepositoryVersionResponse.md)
 - [SetLabel](docs/SetLabel.md)
 - [SetLabelResponse](docs/SetLabelResponse.md)
 - [UnsetLabel](docs/UnsetLabel.md)
 - [UnsetLabelResponse](docs/UnsetLabelResponse.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="basicAuth"></a>
### basicAuth

- **Type**: HTTP basic authentication

<a id="cookieAuth"></a>
### cookieAuth

- **Type**: API key
- **API key parameter name**: sessionid
- **Location**: 


## Author

pulp-list@redhat.com


